#ifndef CSPRNG_H
#define CSPRNG_H

#include<list>
using namespace std;

class csprng {
	#define VERSION    "0.1.0"
	#define SEED_LEN   65535

	private:
		char* seed1;
		char* seed2;
		list<char>* last1;
		list<char>* last2;
		unsigned int seedIndex;
		
		void initLists();
		void initSeed();

	public:
		csprng();
		csprng(char* seed, unsigned int count);
		~csprng();
		static void generateSeed(char* seed, unsigned int count);
		void seed(char* seed, unsigned int count);
		void getRandom(void* result, unsigned int count);
};

#endif